//
//  Enemy.hpp
//  papTermOneCourseWork
//
//  Created by Charles Ringer on 31/10/2015.
//
//

#ifndef Enemy_hpp
#define Enemy_hpp

#include <stdio.h>
#include "Wall.hpp"
#include "ofMain.h"

class Enemy
{
private:
    //All of the vars are private
    
    //Location of the top left corner of the enemy
    int X;
    int Y;
    
    //Height and width
    int width;
    int height;
    
    //How fast they move
    int speed;
    
    //Direction they are moving/facing
    int dir; //0 - up, 1 - right, 2 - down, 3 - left
    
    //We will loop through the vector is images to aminate the sprite.
    //The int tracks where we are in the loop
    int currentDisp = 0;
    vector<ofImage> walking;
    
public:
    //Constructor
    Enemy(vector<Wall> &walls);
    
    //Gets the X and Y of the upper left corner
    int getSX(){return X;};
    int getSY(){return Y;};
    
    //Gets the X and Y of the lower right corner
    int getEX(){return X+width;};
    int getEY(){return Y+height;};
    
    //Gets the height and width
    int getWidth(){return width;};
    int getHeight(){return height;};
    
    //This moves the Enemy (with respect to the walls
    void move(vector<Wall> &walls);
    
    //This displays the enemy
    void disp();
    
    //This checks if the enemy can move in that direction
    bool canMove(char dir, vector<Wall> &walls);
};

#endif /* Enemy_hpp */
