#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    // Smooth edges
    ofEnableSmoothing();
    
    
    
    std::ifstream wallFile (ofToDataPath("levelwalls.txt").c_str());
    

    if (wallFile.is_open())
    {
        int wallSX, wallSY, wallEX, wallEY;
        while (wallFile >> wallSX >> wallSY >> wallEX >> wallEY)
        {
            walls.push_back(Wall(wallSX, wallSY, wallEX, wallEY));
        }
    }
    end = new Endpoint(walls);
    player = new Player(walls);
    for (int i = 1; i < 10; i++)
    {
      enemies.push_back(Enemy(walls));
    }
    verdana.load("verdana.ttf", 14);
    bgImage.loadImage("Assets/Background/0.png");
    
}
//--------------------------------------------------------------
void ofApp::update(){
    if (state == 0)
    {
        player->move(walls);
        cout << ofDist(player->getCenterX(), player->getCenterY(), end->getCenterX(), end->getCenterY()) << endl;
        for(auto &enemy : enemies)
        {
            enemy.move(walls);
        }
        state = player->checkGameEnd(enemies, end);
    }
}

//--------------------------------------------------------------
void ofApp::draw(){
    if (state == -1)
    {
        ofBackgroundGradient(ofColor::gray,ofColor(30,10,30), OF_GRADIENT_CIRCULAR);
        verdana.drawString("Game Over", 200, 200);
    } else if (state == 0)
    {
        bgImage.draw(0,0);
        end->disp();
        for(auto &enemy : enemies)
        {
            enemy.disp();
        }
        vision->disp(player);
        player->disp();
 
    } else if (state == 1)
    {
        ofBackgroundGradient(ofColor::gray,ofColor(30,10,30), OF_GRADIENT_CIRCULAR);
        verdana.drawString("You Won", 200, 200);
    }

}

//--------------------------------------------------------------
void ofApp::keyPressed(int key){
    player->handleKeyOn(key);

}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){
    player->handleKeyOff(key);
}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){
    cout << "Mouse X" << x << "MouseY" << y << endl;
}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){

}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){

}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}
